part of commons;

Future<dynamic> push<T extends ChangeNotifier>(
  Widget screen, [
  T? provider,
]) async {
  return Navigator.of(ContextService.context).push(
    MaterialPageRoute(
      builder: (_) {
        return provider != null
            ? ChangeNotifierProvider(create: (_) => provider, child: screen)
            : screen;
      },
    ),
  );
}

void pushReplacement<T extends ChangeNotifier>(Widget screen, [T? provider]) {
  Navigator.of(ContextService.context).pushReplacement(
    MaterialPageRoute(
      builder: (_) {
        return provider != null
            ? ChangeNotifierProvider(create: (_) => provider, child: screen)
            : screen;
      },
    ),
  );
}

void pushClear<T extends ChangeNotifier>(Widget screen, [T? provider]) {
  Navigator.of(ContextService.context).pushAndRemoveUntil(
    MaterialPageRoute(
      builder: (context) {
        return provider != null
            ? ChangeNotifierProvider(create: (_) => provider, child: screen)
            : screen;
      },
    ),
    (route) => false,
  );
}

Future pop({dynamic result}) async =>
    Navigator.of(ContextService.context).pop(result);
